import javax.swing.*;          //Swing benutzen (Fuers Anzeigemenue: DispMenu) 
import dispmenu.dispmenu.*;    //Fuer: Anzeigemenue -> DispMenu  
import framework.jogl.*;       //Fuer: JOGLMainListener, JOGLMainFrame   
import java.awt.DisplayMode;   //Displaymode-Objekt, falls kein Anzeigemenue gewuenscht.	
/**
 * Start-Klasse des Frameworks. Hier wird ein
 * JOGLMainFrame erstellt und ein DispMenu (Anzeigemenue).
 * Dem JOGLMainFrame kann mit addJOGLMainListener() ein beliebiger 
 * JOGLMainListener hinzugefuegt werden. Standardmaessig ist hier bereits  
 * ein HeavyweightListener zugeordnet.
 */
public class RunFrameWork
{
   /**
    * Haupteinstiegspunkt des Frameworks.
    * 
    * @param args       Parameteruebergabe an main-Methode().
    *                   Hat hier aber keine Bedeutung. 
    */
    public static void main(String[] args)
    {
        javax.swing.SwingUtilities.invokeLater(new Runnable()
        {
           /**
            * Seperater Thread in dem die einzelnen
            * Hauptkomponenten des Frameworks erstellt und miteinander 
            * verknuepft werden.
            */
            public void run()
            {
                /** Look&Feel von Swing einstellen*/
                JFrame.setDefaultLookAndFeelDecorated(true);
                
                /** JOGLMainFrame erstellen*/
                JOGLMainFrame runFrame = new JOGLMainFrame();
                
                //--------------------------------------------------------------
                // ** Anfang Benutzereinstellungen **
                //--------------------------------------------------------------
                
                /** JOGLMainListener zuordnen*/
                runFrame.addJOGLMainListener(new LWL_balls2D(runFrame));
                /** Alternative, 3D-Raum, mit Kamerasteuerung + Maus */
                //runFrame.addJOGLMainListener(new HWL_balls2D(runFrame));
                
                /** Anzeigemenue verwenden (optional!)*/
                //DispMenu menu = new DispMenu("JOGL Framework V.3.6",runFrame);
                /** Alternative: JOGLMainFrame sofort starten */
                //	(Breite, Hoehe, Farbtiefe, Hertz und Vollbild ja/nein)
                runFrame.runme(new DisplayMode(1280,760,32,85), false);
                
                //--------------------------------------------------------------
                // ** Ende der Benutzereinstellungen **
                //--------------------------------------------------------------
            }
        });
    }
}
